//------------------------------------------------------------------------
// UNIT           : MnForm.pas
// CONTENTS       : CANde - Controller Area Network Delphi Example
// VERSION        : 1.0
// TARGET         : (Inprise's) Borland Delphi 4.0 - 7.0
// AUTHOR         : Jon Welfringer
// STATUS         : Freeware
// INFOS          : Implementation of CAN232 functions from Delphi app.
//
// KNOWN BUGS     : none
// COMPATIBILITY  : Windows 95/98/NT/2000/XP
// RELEASE DATE   : 05/31/2005
//------------------------------------------------------------------------
// FOR UPDATES    : - sorry, no home page -
// BUG REPORTS    : mail to   : Jon@Welfringer.com
//------------------------------------------------------------------------
//
// Copyright (c) 2005 by Jon Welfringer, All rights reseved.
//
//******************************************************************************
//*   Permission to use, copy,  modify, and distribute this software and its   *
//*        documentation without fee for any purpose is hereby granted,        *
//*   provided that the above copyright notice appears on all copies and that  *
//*     both that copyright notice and this permission notice appear in all    *
//*                         supporting documentation.                          *
//*                                                                            *
//* NO REPRESENTATIONS ARE MADE ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY *
//*    PURPOSE. IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.    *
//*   NEITHER MARCO COCCO OR D3K SHALL BE LIABLE FOR ANY DAMAGES SUFFERED BY   *
//*                          THE USE OF THIS SOFTWARE.                         *
//******************************************************************************
unit MnForm;

interface

uses
  // Delphi units
  Windows, Messages, SysUtils, Classes, Controls, Forms, Menus,
  ComCtrls, ExtCtrls, StdCtrls, IniFiles, Graphics, SettingsDlg,
//  Dialogs, ToolWin, ImgList, ClipBrd, Grids, Buttons,
  StrUtils, CPDrv, AboutCANde ;

type
  TMainForm = class(TForm)
    OT_PopupMenu: TPopupMenu;
    OT_ClearCmd: TMenuItem;
    N1: TMenuItem;
    OT_CutCmd: TMenuItem;
    OT_CopyCmd: TMenuItem;
    OT_PasteCmd: TMenuItem;
    cpDrv: TCommPortDriver;
    PageControl_Options: TPageControl;
    TabSheet1_View_CAN_Data: TTabSheet;
    TabSheet2_Set_CAN_Options: TTabSheet;
    TabSheet3_Logging_Options: TTabSheet;
    Bevel1: TBevel;
    Btn_Show_About: TButton;
    GB_StatusFlags: TGroupBox;
    CB_StatusFlag0: TCheckBox;
    CB_StatusFlag1: TCheckBox;
    CB_StatusFlag2: TCheckBox;
    CB_StatusFlag3: TCheckBox;
    CB_StatusFlag4: TCheckBox;
    CB_StatusFlag5: TCheckBox;
    CB_StatusFlag6: TCheckBox;
    CB_StatusFlag7: TCheckBox;
    Btn_StatusFlag: TButton;
    RG_Poll_Options: TRadioGroup;
    Btn_Poll_Options: TButton;
    Btn_CAN_Version: TButton;
    Btn_CAN_Serial: TButton;
    RG_Speed_Options: TRadioGroup;
    RG_CAN_Bitrate: TRadioGroup;
    Btn_Bitrate_Options: TButton;
    Btn_Speed_Options: TButton;
    GB_BTR_Values: TGroupBox;
    Lbl_BTR0: TLabel;
    Lbl_BTR1: TLabel;
    Edit_BTR0: TEdit;
    Edit_BTR1: TEdit;
    Btn_Save_Settings: TButton;
    RG_CAN_Timestamp: TRadioGroup;
    Btn_Timestamps: TButton;
    Btn_Comm_Setup: TButton;
    GB_Startup_Options: TGroupBox;
    Edit_LogFile: TEdit;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    RichEdit_Log: TRichEdit;
    Btn_Edit_Log: TButton;
    Btn_Save_Log: TButton;
    RG_OpenLOG: TRadioGroup;
    RG_OpenCOM: TRadioGroup;
    RG_OpenCAN: TRadioGroup;
    GroupBox2: TGroupBox;
    Edit_Cmd_Len: TEdit;
    Edit_Cmd_ID: TEdit;
    Label4: TLabel;
    Edit_Cmd_Byte1: TEdit;
    Edit_Cmd_Byte2: TEdit;
    Edit_Cmd_Byte3: TEdit;
    Edit_Cmd_Byte4: TEdit;
    Edit_Cmd_Byte5: TEdit;
    Edit_Cmd_Byte6: TEdit;
    Edit_Cmd_Byte7: TEdit;
    Edit_Cmd_Byte8: TEdit;
    UpDown_Cmd_Len: TUpDown;
    GroupBox3: TGroupBox;
    Edit_SendText: TEdit;
    Btn_SendText: TButton;
    Label1: TLabel;
    Label5: TLabel;
    Btn_Send_Cmd: TButton;
    GroupBox4: TGroupBox;
    RichEdit_Replay: TRichEdit;
    Btn_Iterate: TButton;
    GroupBox5: TGroupBox;
    CB_Filter_IDs: TCheckBox;
    LB_Filtered_IDs: TListBox;
    CB_Learn_IDs: TCheckBox;
    LB_Learned_IDs: TListBox;
    Btn_Del_Filter: TButton;
    Btn_Add_Filter: TButton;
    Btn_Add_Learned: TButton;
    LB_Known_IDs: TListBox;
    Lbl_Known_IDs: TLabel;
    Label3: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    GroupBox6: TGroupBox;
    RichEdit_Incoming_Data: TRichEdit;
    Btn_Clear_Incoming: TButton;
    Lbl_IncomingData: TLabel;
    Procedure SendText(outstr : String) ;
    Procedure ProcessReceivedLine(instr : String) ;
    procedure cpDrvReceiveData(Sender: TObject; DataPtr: Pointer;
      DataSize: Cardinal);
    procedure Btn_Clear_AllClick(Sender: TObject);
    procedure Btn_SendTextClick(Sender: TObject);
    procedure Btn_IterateClick(Sender: TObject);
    procedure Btn_Comm_SetupClick(Sender: TObject);
    procedure Btn_CAN_VersionClick(Sender: TObject);
    procedure Btn_Poll_OptionsClick(Sender: TObject);
    procedure Btn_TimestampsClick(Sender: TObject);
    procedure Btn_StatusFlagClick(Sender: TObject);
    procedure Btn_Speed_OptionsClick(Sender: TObject);
    procedure Btn_Bitrate_OptionsClick(Sender: TObject);
    procedure Btn_Show_AboutClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Btn_CAN_SerialClick(Sender: TObject);
    procedure Btn_Add_FilterClick(Sender: TObject);
    procedure Btn_Del_FilterClick(Sender: TObject);
    procedure Btn_Save_SettingsClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Btn_Edit_LogClick(Sender: TObject);
    procedure Btn_Save_LogClick(Sender: TObject);
    procedure RG_OpenCOMClick(Sender: TObject);
    procedure RG_OpenCANClick(Sender: TObject);
    procedure RG_OpenLOGClick(Sender: TObject);
    procedure LB_Learned_IDsDblClick(Sender: TObject);
    procedure Btn_Add_LearnedClick(Sender: TObject);
    procedure UpDown_Cmd_LenClick(Sender: TObject; Button: TUDBtnType);
    procedure Btn_Send_CmdClick(Sender: TObject);
    function  OrdToBin(Value: Integer): string;
  private
  public
  end;

var
  MainForm: TMainForm;
  Log_File : TextFile ;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
var
  AppIni: TIniFile;
begin
  Btn_Show_AboutClick(Sender) ;
  // Load all the settings on startup...
  AppIni := TIniFile.Create(ExtractFilePath(Application.EXEName) + 'CANde.ini') ;
  CPDrv.PortName        := AppIni.ReadString('COMMSETTINGS', 'PORTNAME', '\\.\COM1') ;
  CPDrv.BaudRateValue   := AppIni.ReadInteger('COMMSETTINGS', 'BAUDRATE', 57600) ;
  CPDrv.Databits        := TDataBits(AppIni.ReadInteger('COMMSETTINGS', 'DATABITS',3)) ;
  CPDrv.Parity          := TParity(AppIni.ReadInteger('COMMSETTINGS', 'PARITY', 0)) ;
  CPDrv.StopBits        := TStopBits(AppIni.ReadInteger('COMMSETTINGS', 'STOPBITS', 0)) ;
  CPDrv.HwFlow          := THwFlowControl(AppIni.ReadInteger('COMMSETTINGS', 'HWFLOW', 0)) ;
  CPDrv.SwFlow          := TSwFlowControl(AppIni.ReadInteger('COMMSETTINGS', 'SWFLOW', 0)) ;
  CPDrv.EnableDTROnOpen := AppIni.ReadInteger('COMMSETTINGS', 'ENABLEDTR', 1) = 0 ;
  CPDrv.CheckLineStatus := AppIni.ReadInteger('COMMSETTINGS', 'DEVCHECK', 0) = 0 ;
  CPDrv.CheckLineStatus := AppIni.ReadInteger('COMMSETTINGS', 'DEVCHECK', 0) = 0 ;
  CPDrv.InBufSize       := AppIni.ReadInteger('COMMSETTINGS', 'INBUFSIZE', 2048) ;
  CPDrv.OutBufSize      := AppIni.ReadInteger('COMMSETTINGS', 'OUTBUFSIZE', 2048) ;

  // These are the CAN settings
  RG_Speed_Options.ItemIndex := AppIni.ReadInteger('CANSETTINGS', 'RS232_SPEED', 0) ;
  RG_CAN_Bitrate.ItemIndex   := AppIni.ReadInteger('CANSETTINGS', 'CAN_BITRATE', 0) ;
  RG_Poll_Options.ItemIndex  := AppIni.ReadInteger('CANSETTINGS', 'POLL_OPTIONS', 0) ;
  RG_CAN_TimeStamp.ItemIndex := AppIni.ReadInteger('CANSETTINGS', 'TIMESTAMPS', 0) ;
  Edit_BTR0.Text             := AppIni.ReadString('CANSETTINGS', 'CAN_BTR0', '') ;
  Edit_BTR1.Text             := AppIni.ReadString('CANSETTINGS', 'CAN_BTR1', '') ;

  // These are the known/filtered ID settings.
  LB_Known_IDs.Items.CommaText := AppIni.ReadString('ID_SETTINGS', 'KNOWN_IDs', '') ;
  LB_Filtered_IDs.Items.CommaText := AppIni.ReadString('ID_SETTINGS', 'FILTER_IDs', '') ;

  // These are the startup settings.
  Edit_LogFile.Text := AppIni.ReadString('STARTUP', 'LOGFILE', 'CANde.log') ;

  // NOTE: setting an ItemIndex value automatically calls the RadioGroup validation.
  RG_OpenCOM.ItemIndex := AppIni.ReadInteger('STARTUP', 'OPENCOM', 0) ;
  RG_OpenCAN.ItemIndex := AppIni.ReadInteger('STARTUP', 'OPENCAN', 0) ;
  RG_OpenLOG.ItemIndex := AppIni.ReadInteger('STARTUP', 'OPENLOG', 0) ;

  CB_Filter_IDs.Checked := AppIni.ReadBool('STARTUP', 'FilterIDs', False) ;
  CB_Learn_IDs.Checked := AppIni.ReadBool('STARTUP', 'LearnIDs', False) ;
  AppIni.Free ;

end;



// This is where the serial port object handles incoming data.
// You shouldn't really mess with this, see the function ProcessReceivedLine()
// for specifics on what you might do with an incoming data packet.
procedure TMainForm.cpDrvReceiveData(Sender: TObject; DataPtr: Pointer; DataSize: Cardinal);
var
  i : integer;
  s : string;
begin
  // Convert incoming data into a string
  s := StringOfChar( ' ', DataSize );
  move( DataPtr^, pchar(s)^, DataSize );

  S := Trim(s) + #13 ;
  // Exit if s is empty. This usually occurs when one or more NULL characters
  // (chr(0)) are received.
  while pos( #0, s ) > 0 do
    delete( s, pos( #0, s ), 1 );
  if s = '' then exit;

  // Remove line feeds
  i := pos( #10, s );
  while i <> 0 do
  begin
    delete( s, i, 1 );
    i := pos( #10, s );
  end;

  // Process the buffer line by line.  This breaks the buffer block into discreet lines.
  // If you want to act upon individual ID's and data, do it in ProcessReceivedLine routine.
  i := pos( #13, s );
  while i <> 0 do
  begin
    ProcessReceivedLine(Copy(s,1,i)) ;  // Process the line
    delete( s, 1, i );                  // then delete it.
    i := pos( #13, s );
  end;

end;


Procedure TMainForm.ProcessReceivedLine(instr : String) ;
var
  AddToInComing : Boolean ;
  sid : String ;
  sbits: array[0..7] of char;
  sFlag : string ;
Begin
  // Initialize variable
  AddtoIncoming := true ;

  // Check if we should be looking for the status flags
  If Btn_StatusFlag.Tag > 0 then
    If instr[1] = 'F' then
    Begin
      sFlag := OrdToBin(StrToInt('$' + Copy(instr,2,2))) ;
      sFlag := RightStr(sFlag,8) ;
      CB_StatusFlag0.Checked := StrtoBool(sflag[8]) ;
      CB_StatusFlag1.Checked := StrtoBool(sflag[7]) ;
      CB_StatusFlag2.Checked := StrtoBool(sflag[6]) ;
      CB_StatusFlag3.Checked := StrtoBool(sflag[5]) ;
      CB_StatusFlag4.Checked := StrtoBool(sflag[4]) ;
      CB_StatusFlag5.Checked := StrtoBool(sflag[3]) ;
      CB_StatusFlag6.Checked := StrtoBool(sflag[2]) ;
      CB_StatusFlag7.Checked := StrtoBool(sflag[1]) ;
      Btn_StatusFlag.Tag := 0 ;
    End ;

  // Extract the CAN ID from the received string.
  sid := Copy(instr,2,3) ;
  // If the Filter option is checked, only track those items.
  If CB_Filter_IDs.Checked = True Then
  Begin  // Check if the received ID is in the filter list
    If Pos(sid,LB_Filtered_IDs.Items.CommaText) > 0
      Then AddToIncoming := True
    Else AddToIncoming := False ;
  end ;

  // Only process if flagged true.
  If AddToIncoming = True Then
  Begin
    // If the log option is selected, send text to file.
    If RG_OpenLOG.ItemIndex = 1 Then Write(Log_File, instr) ;

    RichEdit_Incoming_Data.Lines.Add(instr) ;  // Add all if not filtering.

    // track the line count instead of calling the memo count function.
    Lbl_IncomingData.Tag := Lbl_IncomingData.Tag + 1 ;
    Lbl_IncomingData.Caption := 'Incoming Data Packets        '
        + IntToStr(Lbl_IncomingData.Tag) ;
  end ;

  // If we are trying to learn new ID's, check if it already exists, then add.
  If CB_Learn_IDs.Checked = True Then                     // Are we checking for new ID's?
    If Pos(sid, LB_Learned_IDs.Items.CommaText) = 0 Then  // Check if already recorded this session.
      If Pos(sid, LB_Known_IDs.Items.CommaText) = 0 Then  // Check if in list of known id's
        If ((Length(Trim(sid)) = 3) and (instr[1] = 't')) Then
          LB_Learned_IDs.Items.Add(sid) ;

  // Scroll incoming text rich edit
  SendMessage( RichEdit_Incoming_Data.Handle, EM_SCROLLCARET, 0, 0 );
End ;


procedure TMainForm.Btn_Clear_AllClick(Sender: TObject);
begin
  RichEdit_Incoming_Data.Clear ;
  Lbl_IncomingData.Tag := 0 ;
end;


procedure TMainForm.SendText(outStr : String);
var
  lenstr, i : integer ;
begin
  // Send the string out the serial port byte by byte.
  lenstr := Length(outStr) ;
  For i := 1 to lenstr do
     cpDrv.SendChar(outStr[i]);
end;


procedure TMainForm.Btn_SendTextClick(Sender: TObject);
begin
  // Send a single test command.
  SendText(Trim(Edit_SendText.Text) + #13) ;
end;


procedure TMainForm.Btn_IterateClick(Sender: TObject);
var
  i, c : integer;
begin
  // Send each command listed from RichEdit
  c := RichEdit_Replay.Lines.Count - 1 ;
  For i := 0 to c do
  Begin
    Application.ProcessMessages ;
    SendText(RichEdit_Replay.Lines[i] + #13) ;
  end ;
end;



procedure TMainForm.Btn_Comm_SetupClick(Sender: TObject);
var dlg: TSettingsForm;
begin
  // Tell the user we cannot change settings while a connection is active.
  if cpDrv.Connected then
  begin
    if Application.MessageBox( 'Could not change settings while a connection is active.'#13#10+
                               'Close the connection and continue ?',
                               'Confirm',
                               MB_OKCANCEL or MB_ICONQUESTION ) <> ID_OK then exit;
    cpDrv.Disconnect;
    RG_OpenCOM.ItemIndex := 0 ;
  end;
  // Let the user customize the settings.
  dlg := nil;
  try
    dlg := TSettingsForm.Create( Self, cpDrv );
    dlg.ShowModal;
  finally
    dlg.Free;
  end;
  Btn_Save_SettingsClick(Sender) ; // Automatically save the settings.
end;


procedure TMainForm.Btn_CAN_VersionClick(Sender: TObject);
begin
  // Send CAN232 version command.
  SendText( #13 + 'V' + #13 ) ;
end ;



procedure TMainForm.Btn_Poll_OptionsClick(Sender: TObject);
begin  // send CAN232 Poll option command.
  case   RG_Poll_Options.ItemIndex of
    0 : SendText( #13 + 'P' + #13 ) ;
    1 : SendText( #13 + 'A' + #13 ) ;
    2 : SendText( #13 + 'C' + #13 + 'X1' + #13 ) ;  // close port first.
    3 : SendText( #13 + 'C' + #13 + 'X0' + #13 ) ;  // close port first.
  end ;
  Btn_Save_SettingsClick(Sender) ;
end;


procedure TMainForm.Btn_TimestampsClick(Sender: TObject);
begin  // Send CAN232 timestamp ON/OFF commands.
  SendText( #13 + 'Z' + Trim(IntToStr(RG_CAN_TimeStamp.ItemIndex)) + #13 ) ;
  Btn_Save_SettingsClick(Sender) ;
end;


procedure TMainForm.Btn_StatusFlagClick(Sender: TObject);
Var
  s : string ;
begin  // Send CAN232 read-status command.
  If RG_OpenCAN.ItemIndex = 0 Then
    Application.MessageBox( 'Reading status flags only valid when CAN channel is open.',
                            'Error', MB_OK or MB_ICONERROR )
    Else
    Begin
    CB_StatusFlag0.Checked := False ;
    CB_StatusFlag1.Checked := False ;
    CB_StatusFlag2.Checked := False ;
    CB_StatusFlag3.Checked := False ;
    CB_StatusFlag4.Checked := False ;
    CB_StatusFlag5.Checked := False ;
    CB_StatusFlag6.Checked := False ;
    CB_StatusFlag7.Checked := False ;
    Btn_StatusFlag.Tag := 1 ;    // set flag so incoming loop knows to look for this.
    SendText( #13 + 'F' + #13 ) ; // send command to read status flags.
  end ;
end;


procedure TMainForm.Btn_CAN_SerialClick(Sender: TObject);
begin
  // Send CAN232 serial number query.
  SendText( #13 + 'N' + #13 ) ;
end;


procedure TMainForm.Btn_Speed_OptionsClick(Sender: TObject);
var
  strcmd : String ;
begin
  // This sends a U0, U1, etc. based on the index of the item selected.
  // The "C" command is first sent to close the CAN channel.
  strcmd := #13 + 'C' + #13 + 'U'
    + Trim(IntToStr(RG_Speed_Options.ItemIndex)) + #13 ;
    RichEdit_Incoming_Data.Lines.Add(strcmd) ;
    SendText(strcmd) ;
    Btn_Save_SettingsClick(Sender) ;
end;


procedure TMainForm.Btn_Bitrate_OptionsClick(Sender: TObject);
begin
  // This sends a S0, S1, etc. based on the index of the item selected.
  // If the BTR0/BTR1 option is selected, use the Edit fields for input.
  If RG_CAN_Bitrate.ItemIndex = 9 Then
  Begin
    SendText( #13 + 'C' + #13) ;
    SendText( #13 + 's' + Trim(Edit_BTR0.Text) + Trim(Edit_BTR1.Text) + #13) ;
  End Else
    SendText( #13 + 'C' + #13 + 'S'
      + Trim(IntToStr(RG_CAN_Bitrate.ItemIndex)) + #13 ) ;
  Btn_Save_SettingsClick(Sender) ;
end;


procedure TMainForm.Btn_Show_AboutClick(Sender: TObject);
var dlg: TAboutBoxForm;
begin
  dlg := nil;
  try
    dlg := TAboutBoxForm.Create( Self, true );
    dlg.ShowModal;
  finally
    dlg.Free;
  end;
end;


procedure TMainForm.Btn_Add_FilterClick(Sender: TObject);
var
  i : Integer ;
begin
  // Only add highlighted ID's from known ID LB.
  For i := 0 to LB_Known_IDs.Items.Count-1 Do
    If LB_Known_Ids.Selected[i] Then
      // Only continue adding it to the list if it doesn't already exist.
      If Pos(LB_Known_Ids.Items[i], LB_Filtered_IDs.Items.CommaText) = 0 Then
        LB_Filtered_IDs.Items.Add(LB_Known_Ids.Items[i]) ;  // Add the item.
end;


procedure TMainForm.Btn_Del_FilterClick(Sender: TObject);
begin
  // Only delete highlighted ID's from filtered ID LB.
      LB_Filtered_IDs.DeleteSelected ;
end;


procedure TMainForm.Btn_Save_SettingsClick(Sender: TObject);
var
  AppIni: TIniFile;
begin
  AppIni := TIniFile.Create(ExtractFilePath(Application.EXEName) + 'CANDe.ini') ;
  AppIni.WriteString('COMMSETTINGS', 'PORTNAME', CPDrv.PortName) ;
  AppIni.WriteString('COMMSETTINGS', 'BAUDRATE', IntToStr( CPDrv.BaudRateValue)) ;
  AppIni.WriteInteger('COMMSETTINGS', 'DATABITS', Ord(CPDrv.Databits)) ;
  AppIni.WriteInteger('COMMSETTINGS', 'PARITY', Ord(CPDrv.Parity)) ;
  AppIni.WriteInteger('COMMSETTINGS', 'STOPBITS', Ord(CPDrv.StopBits)) ;
  AppIni.WriteInteger('COMMSETTINGS', 'HWFLOW', Ord(CPDrv.HwFlow)) ;
  AppIni.WriteInteger('COMMSETTINGS', 'SWFLOW', Ord(CPDrv.SwFlow)) ;
  AppIni.WriteInteger('COMMSETTINGS', 'ENABLEDTR', Ord(CPDrv.EnableDTROnOpen)) ;
  AppIni.WriteInteger('COMMSETTINGS', 'DEVCHECK', Ord(CPDrv.CheckLineStatus)) ;
  AppIni.WriteInteger('COMMSETTINGS', 'INBUFSIZE', CPDrv.InBufSize) ;
  AppIni.WriteInteger('COMMSETTINGS', 'OUTBUFSIZE', CPDrv.OutBufSize) ;

  // These are the CAN settings
  AppIni.WriteInteger('CANSETTINGS', 'RS232_SPEED', Ord(RG_Speed_Options.ItemIndex)) ;
  AppIni.WriteInteger('CANSETTINGS', 'CAN_BITRATE', Ord(RG_CAN_Bitrate.ItemIndex)) ;
  AppIni.WriteInteger('CANSETTINGS', 'POLL_OPTIONS', Ord(RG_Poll_Options.ItemIndex)) ;
  AppIni.WriteInteger('CANSETTINGS', 'TIMESTAMPS', Ord(RG_CAN_TimeStamp.ItemIndex)) ;
  AppIni.WriteString('CANSETTINGS', 'CAN_BTR0', Edit_BTR0.Text) ;
  AppIni.WriteString('CANSETTINGS', 'CAN_BTR1', Edit_BTR1.Text) ;
  // These are the logging and known/filtered ID settings.
  AppIni.WriteString('ID_SETTINGS', 'KNOWN_IDs', LB_Known_IDs.Items.CommaText) ;
  AppIni.WriteString('ID_SETTINGS', 'FILTER_IDs', LB_Filtered_IDs.Items.CommaText) ;
  // These are the startup options.
  AppIni.WriteString('STARTUP', 'LOGFILE', Edit_LogFile.Text) ;
  AppIni.WriteBool('STARTUP', 'FilterIDs', CB_Filter_IDs.Checked) ;
  AppIni.WriteBool('STARTUP', 'LearnIDs', CB_Learn_IDs.Checked) ;

  AppIni.Free ;

end;


procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  RG_OpenCAN.ItemIndex := 0 ;
  RG_OpenCOM.ItemIndex := 0 ;
  RG_OpenCAN.ItemIndex := 0 ;

  RG_OpenCANClick(Sender) ;
  RG_OpenCOMClick(Sender) ;
  RG_OpenCANClick(Sender) ;
end;


procedure TMainForm.Btn_Edit_LogClick(Sender: TObject);
begin
  If RG_OpenLog.ItemIndex = 1 Then
    Application.MessageBox( 'Turn logging off prior to editing log file.',
                            'Error', MB_OK or MB_ICONERROR )
    Else If Not FileExists(ExtractFilePath(Application.EXEName) + Edit_Logfile.Text) Then
    Application.MessageBox( 'Log file does not exist.'#13#10 +
                            'Please check file name.',
                            'Error', MB_OK or MB_ICONERROR )
    Else RichEdit_Log.Lines.LoadFromFile(Edit_LogFile.Text);
end;


procedure TMainForm.Btn_Save_LogClick(Sender: TObject);
begin
  If RG_OpenLog.ItemIndex = 1 Then
    Application.MessageBox( 'Turn logging off prior to saving edited log file.',
                            'Error', MB_OK or MB_ICONERROR )
    Else RichEdit_Log.Lines.SaveToFile(Edit_LogFile.Text);
end;


procedure TMainForm.RG_OpenCOMClick(Sender: TObject);
begin
  If RG_OpenCOM.ItemIndex = 1 Then
  Begin
    // Do nothing if already connected
    if cpDrv.Connected then
      exit;
    // Try connecting
    if not cpDrv.Connect then
    begin
      Application.MessageBox( 'Could not connect to serial port.'#13#10+
                              'Please, check settings and try again.',
                              'Error',
                              MB_OK or MB_ICONERROR );
      exit;
    end;
  End Else
  Begin
    // Do nothing if not connected
    if not cpDrv.Connected then
      exit;
    // Disconnect
    cpDrv.Disconnect;
    RG_OpenCOM.ItemIndex := 0 ;
  End ;
end;

procedure TMainForm.RG_OpenCANClick(Sender: TObject);
begin
  If RG_OpenCAN.ItemIndex = 1 Then
  Begin
    // Add a separator line in the incoming data list to show where we start/stop
    RichEdit_Incoming_Data.Lines.Add('------------------------------') ;
    SendText( #13 + 'O' + #13 )
  End Else SendText( #13 + 'C' + #13 ) ;

end;

procedure TMainForm.RG_OpenLOGClick(Sender: TObject);
Begin
  If RG_OpenLOG.ItemIndex = 1 Then
  Begin
    // Assign a file handle to the filename.
    AssignFile(Log_File, ExtractFilePath(Application.EXEName) + Edit_Logfile.Text) ;
    If Not FileExists(ExtractFilePath(Application.EXEName) + Edit_Logfile.Text) then
      Rewrite(Log_File)           // Create new file.
      Else Append(Log_File) ;     // Append existing file.

    // Add a new date/time header in the logfile each time it is opened.
    Writeln(Log_File, '========================================') ;
    Writeln(Log_File, 'Logging Started  ' + DateTimeToStr(Now))   ;
    Writeln(Log_File, '========================================') ;
    RG_OpenLOG.Tag := 1 ;
  End Else
  Begin
    If RG_OpenLOG.Tag <> 0 Then
    Begin
      CloseFile(Log_File) ;
      RG_OpenLOG.Tag := 0 ;
    End ;
  End ;
End ;


procedure TMainForm.LB_Learned_IDsDblClick(Sender: TObject);
var
  i : Integer ;
begin
  // Only add highlighted ID's from known ID LB.
  For i := 0 to LB_Learned_IDs.Items.Count-1 Do
    If LB_Learned_Ids.Selected[i] Then
      // Only continue adding it to the list if it doesn't already exist.
      If Pos(LB_Learned_Ids.Items[i], LB_Known_IDs.Items.CommaText) = 0 Then
        LB_Known_IDs.Items.Add(LB_Learned_Ids.Items[i]) ;  // Add the item.
end;


procedure TMainForm.Btn_Add_LearnedClick(Sender: TObject);
var
  i : Integer ;
begin
  // Only add highlighted ID's from known ID LB.
  For i := 0 to LB_Learned_IDs.Items.Count-1 Do
    If LB_Learned_Ids.Selected[i] Then
      // Only continue adding it to the list if it doesn't already exist.
      If Pos(LB_Learned_Ids.Items[i], LB_Known_IDs.Items.CommaText) = 0 Then
        LB_Known_IDs.Items.Add(LB_Learned_Ids.Items[i]) ;  // Add the item.
  // Clear the selected ones after moving to Known ID list.
  LB_Learned_IDs.DeleteSelected ;
end;


procedure TMainForm.UpDown_Cmd_LenClick(Sender: TObject;
  Button: TUDBtnType);
begin
  Edit_Cmd_Len.Text := '    ' + IntToStr(UpDown_Cmd_Len.Position) ;
end;


procedure TMainForm.Btn_Send_CmdClick(Sender: TObject);
var
  tmpStr : String ;
begin
  tmpStr := 't' + Trim(Edit_Cmd_Id.Text) + Trim(Edit_Cmd_Len.Text)
                + Trim(Edit_Cmd_Byte1.Text) + Trim(Edit_Cmd_Byte2.Text)
                + Trim(Edit_Cmd_Byte3.Text) + Trim(Edit_Cmd_Byte4.Text)
                + Trim(Edit_Cmd_Byte5.Text) + Trim(Edit_Cmd_Byte6.Text)
                + Trim(Edit_Cmd_Byte7.Text) + Trim(Edit_Cmd_Byte8.Text) ;
  SendText(#13 + tmpStr + #13) ;
end;


function TMainForm.OrdToBin(Value: Integer): string;
const
  BitsPerByte     = 8;
  BitsPerInteger  = SizeOf(Integer) * BitsPerByte;
var
  I, J: Integer;
  P: PChar;
begin
  SetLength(Result, BitsPerInteger);
  P := PChar(Result) + ((BitsPerInteger - 1) * SizeOf(Char));
  J := Value;
  for I := 0 to BitsPerInteger - 1 do
  begin
    P^ := Chr(48 + (J and $00000001));
    Dec(P);
    J := J shr 1;
  end;
end;


end.
